From gnat@kauri.vuw.ac.nz Sun Jan 16 20:26:22 1994
From: gnat@kauri.vuw.ac.nz (Nathan Torkington)
Date: 11 Jan 1994 23:58:32 GMT

This contains no source yet, and much isn't written.  Comments,
corrections and suggestions gratefully appreciated (although ``go
stick your head in a pig'' is probably not a suggestion I would
appreciate :-).  Thanks,

Nat


Using Xlib

By Nathan Torkington

Copyright (c) 1994, Nathan Torkington.

You may copy this, print it out, or pass it on, provided that you do
not charge for it.

XLIB was written by Themie Gouthas, with assistance from many Usenet
and Internet authors.  It is freeware source code for a graphics
library for PC clones, designed to run with the Borland C/C++
compilers and the Borland assembler.

This file is an introduction to the features provided in XLIB.  This
version of the introduction described XLIB release 6.0.  The author
appreciates the help given by many Usenet readers.

Section I	Installing XLIB
	(a)	The Distribution
	(b)	Building a library
	(c)	Compiling the demonstrations

Section II	Basics Behind Graphics Programming
	(a)	The Video Buffer
	(b)	Palettes
	(c)	The Display Cycle
	(d)	Paging, Scrolling and Start Addresses
	(e)	Clipping
	(f)	Trigonometry and Math

Section III	First Steps with XLIB
	(a)	Changing display mode
	(b)	Cleanup and shutdown
	(c)	Drawing pixels
	(d)	Drawing lines
	(e)	Changing palettes
	(f)	A program to use it all

Section IV	Adding Text
	(a)	Fonts
	(b)	Text
	(c)	Scrolling Text
	(d)	Fading in and out
	(e)	A program to use it all

Section V	Elementary Animations
	(a)	Bitmaps
	(b)	Bouncing a ball
	(c)	Why it has gone wrong
	(d)	Double buffering
	(e)	Gravity and collisions

Section VI	Intermediate Animations
	(a)	Polygons
	(b)	Trigonometry and precalculation
	(c)	Rotation
	(d)	Shortcomings

Section VII	Hidden Line Removal

Section VIII	Texture Mapping

Appendix A	Global Variables

Appendix B	tute01.c (mode, point and line code)

Appendix C	Scrolling Sample Code

Appendix D	Fading Sample Code

Appendix E	tute02.c (text, scrolling and fading)

Appendix F	bounce.c (bouncing ball)

Appendix G	tute03.c (bouncing ball, double buffering)


Section I	Installing XLIB

			    The Distribution

The standard XLIB 6.0 distribution is four .zip files:
	xlib06a.zip	C src and header files for demos and library
	xlib06b.zip	Compiled demos
	xlib06c.zip	Compiled libraries
	xlib06d.zip	Utilities and sample fonts

or one .lzh file:

	xlib60.lzh	No compiled libraries or utilities

The way I would recommend installing them is as follows:

(a) extract the *.h files into the INCLUDE directory.
    eg:
	pkunzip xlib06a.zip *.h \borland\include
    or:
	lha xw=\borland\include xlib60.lha *.h

(b) extract the compiled libraries into the LIB directory.
    eg:
	pkunzip xlib06c.zip \borland\lib
    (.lzh users will need to build the libraries, see the next section)

(c) make a directory for the source to the library
    eg:
	mkdir \code\xlib

(d) extract the *.asm, *.inc, *.c and makefile files into the
    directory from (c).
    eg:
	pkunzip xlib06a.zip *.asm *.inc \code\xlib
    or:
	lha xw=\code\xlib xlib60.lha *.c *.asm *.inc makefile 

(e) extract the compiled demo executables into the directory from (c).
    eg:
	pkunzip xlib06b.zip \code\xlib
    or:
	lha xw=\code\xlib xlib60.lha *.exe

(f) extract the utilities into the directory from (c).
    eg:
	pkunzip xlib06d.zip \code\xlib
    (.lzh users will need to obtain the .zip file to get the
    utilities).

Any files not yet unpacked are documentation only.




			  Building a library

Enter the directory where the xlib source code is.  Type
	make

Some problems have been encountered with the source, making it
uncompilable with some versions of TASM.  To fix this, turn lines of
the form
	proc _foo
where _foo is the name of a procedure, into
	_foo proc

[I am unsure of this]




		     Compiling the Demonstrations

<not yet written>

Section II	Basics Behind Graphics Programming

			   The Video Buffer

The video buffer is a block of memory controlled by the video card.
Each byte in Mode X represents one pixel, allowing for 256 colours in
all.  The memory is arranged in what might seem a strange fashion.

Instead of the obvious ``linear'' memory organisation, where the
bytes correspond to rows of pixels on the screen laid out one after
another, Mode X uses ``planar'' memory organisation.  This is where
the screen is divided into 4 ``planes'', so that every fourth pixel is
in the same plane.

The VGA card overlays the planes in memory, so that each memory
address controls four pixels.  The VGA card lets you change which
plane you are writing to through the use of I/O ports.




			       Palettes

The value of each byte in the video buffer represents the colour of a
pixel on the screen.  However, that value does not directly represent
the colour --- the VGA card uses a palette to store the actual colour
value.  A palette is a structure with 256 entries, each entry being
three bytes that hold the red, green and blue intensities for that
palette entry.

The VGA card lets you change the values of any of the entries in the
current palette, through the use of I/O ports.




			  The Display Cycle

The VGA card controls the redrawing of the screen.  This happens 50
times every second.  The monitor contains a cathode ray tube (CRT)
which fires electrons onto the phosphors of the screen.  It redraws
the screen, 50 times every second, line by line from top left to
bottom right (as we see it).

This redrawing is called drawing a ``frame''.  The time when the CRT
is not drawing, but is moving the position from the bottom right back
up to the top left again is called the ``vertical blank''.

The VGA card reads the current values of the display memory for each
pixel that must be drawn.  This means that the timing of the writes to
display memory is very important.  If the picture in memory is changed
halfway through a frame, half of the old picture will have been drawn
and have of the new picture.  This is called ``shearing'', and looks
bad.

To avoid shearing, the writes to the display memory should be made
during the vertical blank.  This is because no picture is being drawn
during this time, so no shearing can take place.  Of course, this
represents a relatively small period compared to the whole display
cycle, so the obvious method (wait for vertical blank, change the
screen, wait for vertical blank, change the screen, ...) would spend
most of its time waiting for the vertical blank, and couldn't do
anything very time-consuming when it changed the screen.

XLIB provides the option of an interrupt handler that is synchronised
with the vertical blank.  This allows you to make buffers for things
like palette changes to make them take place during the vertical
blank, or simply to raise a flag to let you know when the vertical
blank has passed.




		Paging, Scrolling and Start Addresses

Because the VGA card allows access to four pixels for each byte of
memory, the size of display memory required for a screen is relatively
small compared to the amount of memory on a VGA card.  This means that
you can have more than one logical screen (each logical screen is
called a ``page'').  The VGA card lets you change which page is
visible.

This nicely avoids the problem mentioned in the previous section,
where the vertical-blank is such a small period of time that not much
can be done.  If you write to one page, while the other is being
displayed, then change the pages during the vertical blank, you can
spend an entire frame writing to the display memory without worry of
shearing.

The VGA card also lets you have pages that are larger than the
physical screen.  This, combined with the VGA card's ability to change
where the displayed screen starts, lets you scroll easily.  For
instance, if you have a 320x200 screen, and a 400x300 page, you can
make the VGA card display any 320x200 rectangle within that 400x300
page simply by setting the start address.

The page address is the memory location of the first pixel of a
logical screen (a page).  The start address is the x and y coordinates
of the start of the displayed screen, within the logical screen.  For
instance, a logical screen 400x400 pixels in 320x200 display mode
would let you set the start address to anything between (0,0) and
(80,200).

[what is the maximum area you can define a page to be?]




			       Clipping

Clipping is the restriction of drawing to a specified area.  This lets
you, for instance, have a rectangle on the screen that contains a map
and to scroll that map around without it interfering with the rest of
the page.

There are XLIB calls to clip bitmaps as they are written to the
screen, as well as a call to clip in general.  The header files should
be consulted to tell whether clipping is performed or not for a given
routine.




			Trigonometry and Math

In any non-trivial graphics application, trigonometry and floating
point arithmetic will be needed.  The problem with both these things
is that they are slow in comparison to integer arithmetic,
indirection, and most of the other things the chip can do.  The
traditional solution to these problems is to use lookup tables for
trigonometric functions (sine, cosine, tangent, etc) and to replace
floating-point arithmetic with integer equivalents.

Section III	First Steps with XLIB

			Changing display mode

The two XLIB calls that affect the display mode are:

	void x_text_mode(void);

and	int x_set_mode(WORD mode, WORD WidthInPixels);

x_text_mode() sets the VGA card to the standard 80x25 text mode.
x_set_mode() sets the VGA card to the specified mode (see xlib.h for
the symbols to use to define the mode), and defines the page width as
WidthInPixels.  Both functions clear the screen, and x_set_mode()
initialises the palette.

Because of the planar organisation of the VGA memory and the utility
of word-aligned memory, the WidthInPixels can only be a multiple of
eight.  If WidthInPixels isn't a multiple of eight, it is rounded
down.  x_set_mode() returns the actual page width (in pixels).

x_set_mode() also initialises a lot of global variables, listed in
xlib.h.  They are described in more detail in Appendix A.




			 Cleanup and shutdown

If you x_set_mode(), you should use x_text_mode() to return to a text
mode.  If you use the vsync handler (see Section V) you will need to
call x_remove_vsync_handler() to remove the interrupt handler from
memory.  If you use the mouse driver, you will need to call
x_mouse_remove().

The standard way to do this is to define a procedure as follows:

	void exitfunc(void) {
	  x_mouse_remove();	/* if you used the mouse code */
	  x_remove_vsync_handler();	/* if you used the handler */
	  x_text_mode();
	}

and then call

	atexit(exitfunc);

in your startup code.  This ensures that when the program exits with
the exit() call or by falling out of main(), exitfunc() will be
called.

To trap Control-Breaks, which could leave your system still with
interrupt handlers and wrong video modes going, use

	int terminate(void) {
	  exit(0);
	}

and put

	ctrlbrk(terminate);

in your startup code.  This ensures that when Control-Break is hit,
exit() is called, which will in turn call exitfunc() which will return
things to their normal state.




			    Drawing pixels

The XLIB routines to draw pixels are in the xpoint module, so xpoint.h
will contain the prototypes for the functions:

	void x_put_pix(WORD X,WORD Y,WORD PageOffset, WORD Color);

	WORD x_get_pix(WORD X, WORD Y, WORD PageBase);

x_put_pix() sets the palette entry number (the ``colour'') of the
pixel at coordinates (X,Y) from the page beginning at PageOffset.  An
example of this call would be:

	x_put_pix(12, 12, Page0_Offs, 0);

which would set the colour of the pixel 12 columns in and 12 rows down
on Page 0 (the default page) to colour 0.

x_get_pix() returns the palette value (the ``colour'') of the
specified pixel (given in X and Y coordinates from a page offset).
For instance:

	col = x_get_pix(12, 12, Page0_Offs);

would set col to the colour in the given pixel.




			    Drawing lines

The XLIB routine to draw a line is:

	extern void x_line(WORD x0,WORD y0,WORD x1,WORD y1,
	                   WORD color,WORD PageBase);

Where (x0,y0) are the coordinates of the start of the line, and
(x1,y1) are the coordinates of the end of the line, color is the
palette entry number for the pixels along the line, and PageBase is
the page offset to use.  For instance:

	x_line(0, 0, 320, 200, 1, Page0_Offs);

would draw a line from (0,0) (the top-left) to (320,200) in the colour
in palette entry 1, on page 0.

This function doesn't respect the clipping (Section II) area.




			  Changing palettes

The XLIB palette code defines two types of palette structures --- raw
and annotated.  Raw palettes are simply arrays of red, green and blue
byte values.  Annotated palettes are raw palettes with a two byte
header --- the first byte is the number of the first colour entry in
the palette, and the second byte is the number of palette entries in
the structure.

The primitives are:

	extern void x_get_pal_raw(BYTE far * pal, WORD num_colrs,
	                          WORD start_index);

	extern void x_put_pal_raw(BYTE far * pal, WORD num_colrs,
	                          WORD start_index);

	extern void x_get_pal_struc(BYTE far * pal, WORD num_colrs,
	                            WORD start_index);

	extern void x_put_pal_struc(BYTE far * pal);

	extern x_set_rgb(BYTE color, BYTE red_c, BYTE green_c,
	                 BYTE blue_c);

	extern void x_rot_pal_struc(BYTE far * pal, WORD direction);

	extern x_rot_pal_raw(BYTE far * pal,WORD direction,
	                     WORD num_colrs);

	extern  void x_put_contrast_pal_struc(BYTE far * pal,
	                                      BYTE intensity);

	extern void x_transpose_pal_struc(BYTE far * pal,
	                                  WORD StartColor);

	extern WORD x_cpcontrast_pal_struc(BYTE far *src_pal,
	                                   BYTE far *dest_pal,
	                                   BYTE Intensity);

The simplest ones are x_set_rgb(), x_get_pal_raw() and
x_put_pal_raw().  The difference between the annotated palette and raw
palette functions is that annotated palettes keep the number and start
in the palette structure, but raw palette functions are passed those
values as arguments.

x_set_rgb() changes the palette entry given as the first argument.
The second, third and fourth arguments are the red, green and blue
intensity values for that palette entry.

x_get_pal_raw() copies a subsection of the current palette to a raw
palette structure in memory.  x_put_pal_raw() sets the current palette
>from a raw palette structure in memory.  An example of the use of all
three functions is given below:

	#include <malloc.h>

	/* ... */

	  /* 16 is the number of colours we'll deal with */
	  char far *raw_pal = (char far *)farmalloc(3*16);

	  /* get the first 16 palette entries */
	  x_get_pal_raw(raw_pal, 16, 0);
	  x_set_rgb(0, 64, 0, 0);		/* turn up the red */
	  x_put_pal_raw(raw_pal, 16, 0);	/* turn it back again */




		       A program to use it all

The program in Appendix B, tute01.c, demonstrates the use of these
functions.  It enters a graphics mode, draws some pixels, draws some
lines, then changes the palette until a key is pressed, at which point
it closes down gracefully.

Note that the palette changes are *slow*.  This is because operations
on the palette involve *lots* of I/O instructions, which are the
slowest thing to do with the VGA.

You will note that there is no waiting for the vertical blank before
the code draws.  This is because the palette changing code in XLIB
waits for the vertical blank.

Section IV	Adding Text

				Fonts

The XLIB routines that deal with fonts are prototyped in the header
file xtext.h.  The routines are:

	extern WORD x_text_init(void);

	extern void x_set_font(WORD FontId);

	extern void x_register_userfont(char far *UserFontPtr);

The header file also defines some macros, representing Font IDs.  The
xtext module allows three fonts: FONT_8x8 (the standard 8x8 hardware
font), FONT_8x15 (the standard 8x15 hardware font) and FONT_USER (a
user-definable font).

Before using x_set_font() or x_register_userfont(), you must call
x_text_init() which initialises variables:

	CharHeight	BYTE	Height of current inbuilt character set

	CharWidth	BYTE	Width of current inbuilt character set

	FirstChar	BYTE	First character of current inbuilt
				character set

	UserCharHeight	BYTE	Height of current user character set

	UserCharWidth	BYTE	Width of current user character set

	UserFirstCh	BYTE	First character of current user
				character set

All of these variables are read-only.  The user font structure is

	struct {
	  WORD FirstASCII;	/* ASCII code of first char in font */
	  BYTE CharHeight;	/* height in pixels of each char */
	  BYTE CharWidth;	/* width in pixels of each char */
	  BYTE data[CharWidth*CharHeight];	/* bitmap data */
	};

The maximum width of each user-defined character is 8 pixels, but the
maximum height is 255.  The onus is on the user to check that the user
font supports all the characters displayed.




				 Text

XLIB provides several functions to assist with displaying text to a
graphics screen in the selected user font.  Remember to x_text_init():

	void x_put_char(char ch, WORD X, WORD Y, WORD PgOffs,
	                WORD Color);

	void x_printf(int x, int y, unsigned ScrnOffs, int color,
	              char *ln, ...);

	void x_bgprintf(int x, int y, unsigned ScrnOffs, int fgcolor,
	                int bgcolor, char *ln,...);

	unsigned int x_get_char_width(char ch);

x_put_char() places one character at a given coordinate.  x_printf()
works like printf().  x_bgprintf() allows you to specify the
foreground and background colours (the other functions simply mask the
character onto the screen in the specified foreground colour).




			      Scrolling Text

One standard technique in the repertoire of graphics programmers is
the scrolling text message.  This looks impressive (especially to the
person who coded it) and is comparatively easy to do well.

The way to code a scroller (as they are called) is to fill the screen
up with text, then copy the rectangle with the text in across the
screen, one pixel at a time, until a character has been shifted off
the edge, then refill the screen and continue.

Some code that does this is given in Appendix C, below.




			  Fading in and out

Another simple but effective technique is palette fiddling to fade in
and out of a scene.

The easiest way to do this is to draw your picture, but with a palette
set entirely to black.  Then, slowly build up the red, green and blue
values until you have the palette you want.  The code in Appendix D
does this.




		       A program to use it all

The program in Appendix E, tute02.c, fills part of the screen with
lines, scrolls some text across the bottom, with fades in and out.

Section V	Elementary Animations

			       Bitmaps

The bitmap handling code in XLIB is quite varied.  There are three
main types of bitmap --- planar, compiled and video bitmaps.  Planar
bitmaps are stored with the bytes in an efficient order for painting,
but can be slow to place on screen.  Compiled bitmaps are larger in
memory, but quicker to place.  Video bitmaps are a compromise.

This section only deals with planar bitmaps, which are currently
limited to be a multiple of four pixels wide.  The routines for using
planar bitmaps without clipping are:

	void x_put_masked_pbm(WORD X, WORD Y, WORD ScrnOffs,
	                      BYTE far * Bitmap);

	void x_put_pbm(WORD X, WORD Y, WORD ScrnOffs,
	               BYTE far * Bitmap);

	void x_get_pbm(WORD X, WORD Y, BYTE Bw, BYTE Bh,
	               WORD ScrnOffs, BYTE far * Bitmap);

Those that perform clipping take identical arguments to those above,
and are:

	x_put_pbm_clipx

	x_put_pbm_clipy

	x_put_pbm_clipxy

	x_put_masked_pbm_clipx

	x_put_masked_pbm_clipy

	x_put_masked_pbm_clipxy


x_put_pbm() and the related clipped functions, place a bitmap onto the
screen.  x_put_masked_pbm() and related clipped functions overlay,
only placing pixels with non-zero colour onto the screen.

x_get_pbm() copies an area of the screen into a bitmap structure.  The
planar bitmap structure is:

	struct {
	  BYTE width;	/* bitmap width in bytes (1 byte == 4 pixels) */
	  BYTE height;	/* bitmap height in pixels */
	  BYTE plane_0_data[width*height];	/* pl. 0 bitmap data */
	  BYTE plane_1_data[width*height];	/* pl. 1 bitmap data */
	  BYTE plane_2_data[width*height];	/* pl. 2 bitmap data */
	  BYTE plane_3_data[width*height];	/* pl. 3 bitmap data */
	};

and the formula for working out how much memory to allocate for the
bitmap is:

	size = 2 + width*height;	/* width and height in pixels */




			   Bouncing a ball

Appendix F contains bounce.c, the source for a program which bounces
the bitmap of a ball across the screen.  The speed of the ball in the
x and y directions is constant.

bounce.c includes a test for the vertical blank, to ensure that when
we write to the screen, we won't get shearing.  Unfortunately, we do.




			Why it has gone wrong

The bouncing ball program has one glaring problem --- the ball
flickers.  The reason for this is that the calculations and the bitmap
reading and writing is taking longer than the vertical blank time.  As
a result, the screen is drawing the frame while we're still writing
it.  That's why the ``cheese-grater'' effect of the ball appearing to
disappear towards the top of the screen is happening.

To fix this, we need to either improve our code so that it takes less
than or the same time as the vertical blank, or get around the problem
some other way.  It is obvious that the code can only be improved a
little, and that if we were forced to do everything in the vertical
blank, we would have no time to do anything.

The way around this is a technique called ``double buffering''.




			   Double Buffering

Double buffering is the technique described in Section 1, whereby you
keep two pages in memory.  One is being displayed, and the other is
being written on.  When the writing is finished, the pages are swapped
on the next vertical blank, and writing continues on the page which
was previous displayed.

This technique gives you an entire frame to write to a page, rather
than just the length of the vertical blank.  This prevents the problem
encountered in the previous example, where even the most trivial code
usually exceeds the time of the vertical blank.

Although we can use double buffering without the vertical sync
interrupt, now is a good time to introduce its use.  Appendix G
contains the source to the bouncing ball program rewritten to use
double buffering and the vsync handler.




			Gravity and collisions

An interesting effect to add is gravity.  This is where we assume
there is a force acting downwards on the ball all the time.  This
force accelerates the ball, changing its speed.  The effect of this is
that each successive frame moves the ball more pixels on the way down,
and fewer on the way up.

Collisions are harder.  The elementary method is to see whether the
bitmaps overlap, but as the bitmaps often contain 0 bytes, which
appear invisible when the bitmap is masked onto the screen, the
visible parts of the bitmap often don't extend to its edge.  For this
reason, you can either rewrite the bitmap routines (YakIcons uses this
approach), or use a more complex test.

One such test is:
	If the two bitmaps don't overlap, they're not colliding, so
	    return false.
	Calculate the areas which overlap (one rectangle from each
	    bitmap).
	Compare the overlapping areas and see if a non-zero byte
	    appears in both.  If so, return true.
	Return false.



Appendix A

[Not yet written.]

Appendix B

tute01.c

Appendix C

Scrolling Sample Code

Appendix D

Fading Sample Code

Appendix E

tute02.c

Appendix F

bounce.c

Appendix G

bouncedb.c


